package de.ipk.batex.persistence.dataAccess;

import java.sql.Connection;
import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Restrictions;

abstract class AbstractDao<T > {
	

	protected final Logger logger;
	private final Class clazz;
	
	/**
	 * 
	 * @param t An instance of T
	 */
	public AbstractDao(T t){
		logger = Logger.getLogger(this.getClass());
		clazz=t.getClass();
	}
	
	public void save(T t, Connection con) {
		Session s = HibernateUtil.getSession(con);
		Transaction transaction =s.beginTransaction();
		s.save(t);
		transaction.commit();
	}
	
	public void saveOrUpdate(T t, Connection con) {
		Session s = HibernateUtil.getSession(con);
		Transaction transaction =s.beginTransaction();
		s.saveOrUpdate(t);
		transaction.commit();
	}
	
	public void delete(T t, Connection con) {
		Session s = HibernateUtil.getSession(con);
		Transaction transaction =s.beginTransaction();
		s.delete(t);
		transaction.commit();
	}	
	
	public List<T> getAll(Connection con){

		Session s = HibernateUtil.getSession(con);
		Transaction tx =s.beginTransaction();

		List<T> t = s.createCriteria(clazz).list();
		
		tx.commit();
		return  t;
	}	
	
	public T getById(Integer id, Connection con){
		Session s = HibernateUtil.getSession(con);
		Transaction tx =s.beginTransaction();

		T t = (T)s.createCriteria(clazz).add(Restrictions.idEq(id)).uniqueResult();
		
		tx.commit();
		return  t;
	}

}
