package de.ipk.batex.persistence.dataAccess;

import java.sql.Connection;
import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import de.ipk.batex.persistence.model.BioMaterial;
import de.ipk.batex.persistence.model.Experiment;

public class BioMaterialDao {

	public List<BioMaterial> getAll(Connection con) {

		Session s =HibernateUtil.getSession(con);
		Transaction tx = s.beginTransaction();

		List<BioMaterial> t = s.createCriteria(BioMaterial.class).list();
		tx.commit();
		return t;
	}

	public List<BioMaterial> getAllOfExp(Experiment exp,Connection con){
		List<BioMaterial> mats;

		Session s =HibernateUtil.getSession(con);
		Transaction tx = s.beginTransaction();

		Query q = s.getNamedQuery("allMatOfExp");
		q.setParameter(0, exp.getId());
		mats=q.list();

		tx.commit();

		return mats;
	}
}
