package de.ipk.batex.persistence.dataAccess;

import java.sql.Connection;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Restrictions;

import de.ipk.batex.persistence.model.Experiment;

public class ExperimentDAO extends AbstractDao<Experiment>{

	public ExperimentDAO(){
		super(new Experiment());
	}
	
	public List<Experiment> getAll(Connection con){

		Session s = HibernateUtil.getSession(con);
		Transaction tx =s.beginTransaction();

		List<Experiment> t = s.createCriteria(Experiment.class).list();
		tx.commit();
		return  t;
	}
	
	public List<Experiment> getByName(String namePattern,Connection con){
		Session s =HibernateUtil.getSession(con);
		Transaction tx =s.beginTransaction();

		List<Experiment> t = s.createCriteria(Experiment.class).add(Restrictions.like("name", namePattern)).list();
		tx.commit();
		return  t;		
	}
}
