package de.ipk.batex.persistence.extendedModel;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import de.ipk.batex.persistence.model.Term;
import de.ipk.batex.persistence.model.TrmCategory;

public class TrmCategoryTreeTerm extends TrmCategory {


	private static final long serialVersionUID = 1L;

	private TrmCategoryTreeTerm trmCategoryParent;
	
	

	private Set<TrmCategoryTreeTerm> trmCategoryChilds = null; //new HashSet<TrmCategoryTreeTerm>();

	private Set<Term> terms = null; //new HashSet<Term>(0);

	// Constructors
	
	public TrmCategoryTreeTerm(TrmCategory tct){
		super(tct.getParentTctId(),tct.getTctName(),tct.getTctDesc());
		setId(tct.getId());
	}
	
	public TrmCategoryTreeTerm(TrmCategory tct, TrmCategoryTreeTerm parent, Collection<TrmCategoryTreeTerm> childs, Collection<Term> terms) {

		this(tct);
		
		if (terms != null){
			this.terms = new HashSet<Term>(terms);
		}
		
		if(childs !=null){
			this.trmCategoryChilds=new HashSet<TrmCategoryTreeTerm>(childs);
		}
		this.trmCategoryParent=parent;
	}

	/** default constructor */
	public TrmCategoryTreeTerm() {
	}

	public TrmCategoryTreeTerm getTrmCategoryParent() {
		return this.trmCategoryParent;
	}

	public void setTrmCategoryParent(TrmCategoryTreeTerm trmCategoryParent) {
		this.trmCategoryParent = trmCategoryParent;
	}


	public Set<TrmCategoryTreeTerm> getTrmCategoryChilds() {
		return this.trmCategoryChilds;
	}

	public void setTrmCategoryChilds(Set<TrmCategoryTreeTerm> trmCategoryChilds) {
		this.trmCategoryChilds = trmCategoryChilds;
	}

	public Set<Term> getTerms() {
		return this.terms;
	}

	public void setTerms(Set<Term> terms) {
		this.terms = terms;
	}

	
}