package de.ipk.batex.persistence.model;

public abstract class AbstractObject implements IObject {

	@Override
	public final boolean equals(Object other) {

		if ((this == other))
			return true;
		if ((other == null))
			return false;
		if (!(other instanceof AbstractObject))
			return false;
		AbstractObject castOther = (AbstractObject) other;

		return ((this.getId() == castOther.getId()) || (this.getId() != null
				&& castOther.getId() != null && this.getId().equals(
				castOther.getId())));
	}

	@Override
	public final int hashCode() {
		int result = 17;

		result = 37 * result
				+ (getId() == null ? 0 : this.getId().hashCode());

		return result;
	}

	@Override
	public final String toString() {
		return "["+this.getClass().getSimpleName()+" ID:"+getId()+"  name:"+getName()+"  identifer:"+getIdentifier()+"]";
	}

}
